# wBuild

Automatic build tool for R Reports

## Documentation

Full documentation is available at https://wbuild.readthedocs.io

## Features

* Supports reproducible research
  * Append R-markdown scripts to the Snakemake pipeline
* Render the R scripts to a structured web page
* Snakemake rules written directly in the header of scripts
  * Dependencies updated automatically!

## Installation

Install using pip:

- `pip install wBuild`

See "Installation" tab in the documentation for more details.

## Getting started
  
* Navigate to an empty directory
* Run `wbuild demo`. This will create a wBuild demo project with various examples
* Explore the files in `Scripts/`
* Run `snakemake` to build the project
* Open `Output/html/index.html` in your web browser
  * There you will find useful and understandable examples of features and operations with wBuild

## Usage

* Navigate to the root of your project (new or existing)
* Run `wbuild init`
* Run `snakemake`

## GitHub

wBuild is an open-source software. The source-code is available at https://github.com/gagneurlab/wBuild.

## Credits

Leonhard Wachutka

# wBuild

Automatic build tool for R Reports

## Features


* Enables reproducible research by appending every R-markdown script to the global analysis pipeline written in snakemake
* All R scripts using R-markdown get compiled via Rmarkdown and rendered in a navigable web-page
* This is achieved by writing the snakemake rules directly in the header of your R scripts
  * Headers allow the same flexibility (i.e. usage of python) as in the traditional Snakefile

## Installation

- `pip install wBuild`

Within the Gagneurlab, load python version /opt/modules/i12g/anaconda/3-4.1.1/ using module system..

## Getting started
  
* Navigate to an empty directory
* Run `wbuild demo`. This will create a wBuild demo project with various examples.
* Explore the files in `Scripts/`
* View the compiled version of the demo project: <https://i12g-gagneurweb.in.tum.de/project/wBuild/>
* Run `snakemake` to compile the projects
* Open `Output/html/index.html` in your web browser.

## Usage

* Navigate to the root of your project (new or existing)
* Run `wbuild init`
* Run `snakemake`
  
## Documentation

- Run `wbuild --help` or `wbuild <command> --help` to learn more about available wBuild commands.
- See the documentation/demo page at <https://i12g-gagneurweb.in.tum.de/project/wBuild/>


## Credits

Leonhard Wachutka

# Welcome to the wBuild demo project!

wBuild is all about making your day easier resolving, updating and cascading various dependencies, pipeline rules and
code structs. Why bother clicking various files and directories in your project one-by-one? Instead of that, wBuild lets you
specify all the needed information in a YAML header right in your code and let the automated Snakemake processes do the rest!

This is a demonstration of the features wBuild provides. By default there are various scripts and markdown files from a 
project rendered 
to this HTML output where you can learn more about features and workflow of wBuild - they are available at the most right
tab in the header.

#'---
#' title: Basic Input Output Demo
#' author: Leonhard Wachutka
#' wb:
#'  input: 
#'  - pca: "{wbPD_P}/pca.RDS"
#' output:
#'  html_document:
#'   code_folding: show
#'   code_download: TRUE
#'---

# The following two commands make it possible to run wbReadRDS or snakemake@inputs
# while running in the interactive R session (say in RStudio)
source('.wBuild/wBuildParser.R')
parseWBHeader("Scripts/Analysis1/020_InputOutput/030_VisualizePCA.R")

##' ## Load pca data and visualize the first two principle components
pca <- wbReadRDS("pca") # shorthand for readRDS(snakemake@input[["pca"]])
plot(pca[, 1], pca[, 2], col = pca$Species)

parseWBHeader = function(filename)
{
	if(exists('snakemake') && snakemake@rule != 'WB')
	{
		filename = snakemake@input[['RScript']]
	}
	
	library(stringr)
	wbPD = 'Output/ProcessedData'
	wildcards = list(
			`wbPD` = 'Output/ProcessedData',
			`wbP` = str_split(filename,'/')[[1]][2],
			`wbPP` = str_split(filename,'/')[[1]][3],
			`wbPD_P` = paste(wbPD,str_split(filename,'/')[[1]][2],sep ="/"),
			`wbPD_PP` = paste(wbPD,str_split(filename,'/')[[1]][2],str_split(filename,'/')[[1]][3], sep='/'))
	
	if(!exists('snakemake') || snakemake@rule == 'WB')
	{
		library(methods)
		library(yaml)
		library(magrittr)
		library(gsubfn)
		
		wb = readLines(filename)%>%str_subset("^#'")%>%str_replace("^#'",'')%>%paste0(collapse='\n')%>%
				str_replace("\\n---(.|\\n)*",'')%>%yaml.load%>%`[[`('wb')
		
		repList = wildcards
		names(repList) = paste0('{',names(repList),'}')
		
		if(is.null(wb$output))
		{output = list()}
		else
		{output = as.list(gsubfn('\\{[^\\}]+\\}', repList,unlist(wb$output)))}
		
		if(is.null(wb$input))
		{input = list()}
		else
		{input = as.list(gsubfn('\\{[^\\}]+\\}', repList,unlist(wb$input)))}
		
		
		Snakemake <- setClass(
				"Snakemake",
				slots = c(
						input = "list",
						output = "list",
						params = "list",
						wildcards = "list",
						threads = "numeric",
						log = "list",
						resources = "list",
						config = "list",
						rule = "character"
				)
		)
		
		snakemake <<- Snakemake(
				input = c(input,list(filename, "RScript" = c(filename))),
				output = output,
				params = list(),
				wildcards = wildcards,
				threads = 1,
				log = list(),
				resources = list(),
				config = list(),
				rule = 'WB'
		)
		
	}
	if(snakemake@rule != 'WB')
	{
		snakemake@wildcards <<- c(wildcards,snakemake@wildcards)
	}
	
	for (w in names(wildcards))
	{
		message(w,': ', wildcards[[w]])
	}
	return(invisible(NULL))
	
}
wbReadRDS = function(name)
{
	message('Read ', snakemake@input[[name]],' ...',appendLF=FALSE)
	temp = readRDS(snakemake@input[[name]])
	message('OK')
	return(temp)
}

wbSaveRDS = function(obj, name)
{
	message('Save ', snakemake@output[[name]],' ...',appendLF=FALSE)
	saveRDS(obj, snakemake@output[[name]])
	message('OK')
}
wbReadFST = function(name)
{
	message('Read ', snakemake@input[[name]],' ...',appendLF=FALSE)
	temp = read.fst(snakemake@input[[name]],as.data.table=TRUE)
	message('OK')
	return(temp)
}
wbSaveFST = function(obj, name)
{
	message('Save ', snakemake@output[[name]],' ...',appendLF=FALSE)
	write.fst(obj, snakemake@output[[name]])
	message('OK')
}

#'---
#' title: Basic Input Demo
#' author: Leonhard Wachutka, Jun Cheng
#' wb:
#'  input: 
#'  - iris: "Data/iris_downloaded.data"
#'  threads: 10
#' output:
#'  html_document:
#'   code_folding: show
#'   code_download: TRUE
#'---
source('.wBuild/wBuildParser.R')
parseWBHeader("Scripts/Analysis1/030_Snakefile/020_Snakefile.R")

read.csv(snakemake@input[['iris']])

message('We run on', snakemake@threads, 'threads')

# R functions
#
# author: daniel bader
#-------------------------------

#' render_child
#' 
#' Analog to knit_child(). Takes an R notebook and spins and knits it to an HTML document.
#' The HTML code is written to STDOUT.
#' 
render_child= function(file, quiet= TRUE, knit_fct= 'knit_child', return=FALSE, knit_flag=FALSE ){
	library(knitr)
	
	textin= readLines(file)
	textout= get(knit_fct)(
			text= spin(text= textin, knit=knit_flag, report=F, format='Rmd'), 
			quiet= quiet
	)
	if(return){
		return(textout)
	}else{
		writeLines(textout)
	}
	rm(list=c('textin', 'textout'))
}


#' rmarkdown_render_on_demand
#' 
#' Function to render a Rscript file on demand, w.r.t. a boolean if clause
#' 
rmarkdown_render_on_demand <- function(script, spin_script, quiet=TRUE){
	
	# generate prot report
	if(spin_script){
		render_child(file=script, quiet= quiet)
	}
}


#' enumerate_htmlwidgets
#' 
#' The input file is scanned for htmlwidget container. If present there IDs will be enumerated, 
#' starting by 1 to avoid ID conflicts, i.e. two container having the same ID.
#' 
enumerate_htmlwidgets= function(infile, outfile= infile, prefix='hw'){
	
	file_by_lines <- readLines(infile)
	counter=1
	
	for(i in 1:length(file_by_lines)){
		line = file_by_lines[i]
		line= sub('id=\"htmlwidget-[0-9]{1,4}', paste0('id=\"', prefix, counter), line)
		
		if(grepl('data-for=\"htmlwidget-[0-9]', line)){
			line= sub('data-for=\"htmlwidget-[0-9]{1,4}', paste0('data-for=\"', prefix, counter), line)
			counter= counter+1
		}
		file_by_lines[i] = line
	}
	writeLines(file_by_lines, outfile)
}


render_clean_html= function(rscript){
	render(rscript, output_format = 'html_document')
	enumerate_htmlwidgets(sub('.R','.html',rscript))
}

#
# wBuild render script
# 

#require(knitrBootstrap)
require(knitr)
require(rmarkdown)
# default for knitr and rmarkdown
opts_knit$set(root.dir=getwd())
opts_chunk$set(echo=TRUE, message=FALSE, 
		error=FALSE, warning=FALSE, cache=FALSE)

# TODO could be an option in the wbuild.yaml
options(width=120)
wBuildPath = snakemake@config[['wBuildPath']]
source(paste0(wBuildPath, "/R/render_child.R"))
source(paste0(wBuildPath, "/R/rmarkdown_show_hide_table.R"))

# create tmp folder and tmp output folder
intermediates_dir <- tempfile()
tmp_output_dir <- tempfile()
i <- dir.create(intermediates_dir, showWarnings=FALSE)
i <- dir.create(tmp_output_dir, showWarnings=FALSE)

# copy needed files over
file.copy(paste0(wBuildPath,"/html/lib"), file.path(tmp_output_dir), recursive=TRUE)

# get snakemake input
file_input <- snakemake@input[['RScript']]
file_output <- snakemake@output[['wBhtml']]


sFile <- tempfile()
spin_input <- readChar(file_input, file.info(file_input)$size)
write(spin(text=spin_input, knit=FALSE), sFile)
kProcessor <- default_output_format(sFile)

# add needed default based on the document type
if (kProcessor$name == "html_document"){
	libPath <- file.path(tmp_output_dir, "libR")
	
	kProcessor$options$code_folding = ifelse(
			is.language(kProcessor$options$code_folding), 
			"hide", kProcessor$options$code_folding)
	kProcessor$options$toc <- TRUE
	kProcessor$options$toc_float <- TRUE
	kProcessor$options$fig_retina <- NULL
	kProcessor$options$self_contained <- FALSE
	kProcessor$options$lib_dir <- libPath
	kProcessor$options$css <- c('lib/add_content_table.css', 'lib/leo_style.css')
    kProcessor$options$df_print <- 'tibble'
}else{
	require(knitrBootstrap)
}
format <- do.call(eval(parse(text=kProcessor$name)), kProcessor$options)

# render it to the tmp folder
render(file_input, output_dir=tmp_output_dir, clean=TRUE,
		intermediates_dir=intermediates_dir, output_file=basename(file_output),
		output_format=format)

# copy it to the output directory
file.copy(list.files(tmp_output_dir, full.names=TRUE),
		dirname(file_output), overwrite=TRUE, recursive=TRUE)

#'---
#' title: Report 1
#' author: Leonhard Wachutka
#' wb:
#'  input:
#'  output:
#' output:
#'  knitrBootstrap::bootstrap_document
#'---

#' #KnitrBootsrap Theme
#' This is tutorial text
#' 
#' 
#' #Next topic
#' 
#' ##Sub Header

plot(1:10,1:10)
#' ##Sub Header2
plot(1:100,1:100)

#' ##Sub Header3
plot(1:10,1:10)

#' #Tutorial 2
#' This is tutorial text
#' 
#' 
#' #Next topic
#' 
#' ##Sub Header
plot(1:10,1:10)

#' rmarkdown_show_hide_table
#' 
#' function to hide/show a container within a rmarkdown html
#' needs to be used with the code chunk option ==> results='asis'
#' 
#' @example within R
#' 		divname='raw'; button='show/hide new table'
#' 		#' <a id="displayText" href="javascript:toggle('`r divname`');">`r button`</a>
#' 		#' <div id="`r divname`" style="display: none" href="javascript:toggle();">
#' 		data_object
#' 		#' </div>
#' 		#' <a id="displayText" href="javascript:toggle('`r divname`');">`r button`</a>
#'
rmarkdown_show_hide_table <- function(name, data_view_cmd, view_function='eval'){

	# generate arbitraty table name; avoid duplicates by chance
	options(digits.secs=6)
	rand_table_name <- paste0("table_", sub(' ','_', Sys.time()))
	rand_id <- paste0("displayText_", sub(' ','_', Sys.time()))
	
	# def html table button
	table_button <- paste0("<p><a id=\"",rand_id,"\" href=\"javascript:toggle('", rand_table_name, 
			"');\">show/hide ", name, "</a></p>")
	
	# put button above container
	cat(table_button)
	
	# print container
	cat("\n<div id=\"", rand_table_name, "\" style=\"display:none\" href=\"javascript:toggle();\">\n", sep="")
	if(is.null(view_function)){
		writeLines('\n')
#		writeLines(data_view_cmd)
		data_view_cmd
		writeLines('\n')
	}else{
		cat("\n<pre>\n<code>\n\n")
		get(view_function)(data_view_cmd)
		cat("\n\n</code>\n</pre>\n\n")
	}
	cat("\n</div>\n")
	
	# put button below container
	cat(table_button)
}

#' knitr_show_hide_container
#' 
#' Shortcut for rmarkdown_show_hide_table, e.g. if data_view_cmd returns directly HTML code
#' 
knitr_show_hide_container <- function(name, data_view_cmd){
	rmarkdown_show_hide_table(name, data_view_cmd, view_function =NULL)
}

rmarkdown_show_hide_table2 <- function(name, data_view_cmd, view_function='eval'){
	
	# generate arbitraty table name; avoid duplicates by chance
	options(digits.secs=6)
	rand_table_name <- paste0("table_", sub(' ','_', Sys.time()))
	
	# put button above
	table_button <- paste("<a id=\"displayText\" href=\"javascript:toggle('", rand_table_name, 
			"');\">show/hide ", name, "</a>", sep="")
	
	# create output
	cat(table_button)
	
	# print container
	cat("\n<div id=\"", rand_table_name, "\" style=\"display: none\" href=\"javascript:toggle();\">\n", sep="")
	if(is.null(view_function)){
		writeLines('')
		writeLines(data_view_cmd)
	}else{
		#cat("\n<pre>\n<code>\n\n")
		get(view_function)(data_view_cmd)
		#cat("\n\n</code>\n</pre>\n\n")
	}
	cat("\n")
	cat("</div>\n")
	
	# put button below container
	cat(paste0("<p>",table_button, "</p>"))
}

#'---
#' title: Basic Input Demo
#' author: Leonhard Wachutka
#' wb:
#'  input: 
#'  - iris: "Data/{wbP}/iris.RDS"
#'  output:
#'  - wBhtml: "Output/html/030_AnalysisOfId_{id}.html"
#'  type: noindex
#' output:
#'  html_document:
#'   code_folding: show
#'   code_download: TRUE
#'---

#important :Output has to be called wBhtml
#type: noindex
# id='SepalLength'
source('.wBuild/wBuildParser.R')
parseWBHeader("Scripts/Analysis1/050_PythonCode/030_AnalysisTemplate.R")

id = snakemake@wildcards[["id"]]
iris_df = wbReadRDS('iris')
colnames(iris_df) = gsub('\\.','',colnames(iris_df))

hist(iris_df[[id]],main=id)

#'---
#' title: Report 1
#' author: Leonhard Wachutka
#' wb:
#'  py:
#'  - test = [1,4]
#'  output: 
#'  - out: "Data/data.RDS"
#'  - outl: "`sm expand('Data/{dataset}.A.txt', dataset=test)`" 
#'  type: script
#'  threads: 8
#' output:
#'  knitrBootstrap::bootstrap_document
#'---

message('Threads: ', snakemake@threads)
message('input: ',str(snakemake@input))
message('output: ',str(snakemake@output),'\n')

message(snakemake@output[['out']])
message(snakemake@output[['outl']])

parallel::mclapply(1:10, function(x) mean(rnorm(1e7)), mc.cores = snakemake@threads)
saveRDS(1:13,"Data/data.RDS")

saveRDS(1:13,snakemake@output[['outl']][1])
saveRDS(1:13,snakemake@output[['outl']][2])

options(repos=structure(c(CRAN="https://cloud.r-project.org")))

print(.libPaths())

packages <- c("data.table", "DT", "gsubfn", "knitr", "magrittr", "methods",
              "rmarkdown", "stringr", "tibble", "yaml")
installed <- rownames(installed.packages())
for (pckg_name in packages) {
    if (pckg_name %in% installed)
        message(paste(pckg_name, "already installed"))
    else
        install.packages(pckg_name)
}

#'---
#' title: SubTask report
#' author: Leonhard Wachutka
#' wb:
#'  input: ['Data/data.RDS']
#'---

#' #Tutorial
#' This is tutorial text
#' 
#' 
#' #Next topic
#' 
#' ##Sub Header
readRDS("Data/data.RDS")
plot(1:10,1:10)
#' ##Sub Header2
plot(1:10,1:10)

#' ##Sub Header3
plot(1:10,1:10)

#' #Tutorial 2
#' This is tutorial text
#' 
#' 
#' #Next topic
#' 
#' ##Sub Header
plot(1:10,2:11)

#'---
#' title: Basic Input Demo
#' author: Leonhard Wachutka
#' wb:
#'  output: 
#'  - ids: "{wbPD_P}/ids.txt"
#'  type: script
#' output:
#'  html_document:
#'   code_folding: show
#'   code_download: TRUE
#'---
source('.wBuild/wBuildParser.R')
parseWBHeader("Scripts/Analysis1/050_PythonCode/020_CreateIDs.R")

ids = c('SepalLength','SepalWidth','PetalLength','PetalWidth')
write.table(ids,snakemake@output[['ids']],row.names=FALSE,col.names=FALSE,quote=FALSE)

#'---
#' wb:
#'  py:
#'  - | 
#'   with open('Data/ids.txt') as f:
#'    ids = f.read().splitlines()
#'  input:
#'  - idslist: "Data/ids.txt"
#'  - columns: "`sm expand('Output/html/030_AnalysisOfId_{id}.html', id=ids)`"
#' output:
#'  html_document:
#'   code_folding: show
#'   code_download: TRUE
#'---

#py can be any valid python code. E.g. we explicitly state here the ids, instead of reading or get them from the config file
#`sm ...` is escape for snakemake syntax
source('.wBuild/wBuildParser.R')
parseWBHeader("Scripts/Analysis1/050_PythonCode/040_IndexIDs.R")


# Ok now we need to show the ids
#' #Example of two links using markdown syntax
#' 
#' - [id1](030_AnalysisOfId_SepalLength.html)
#' - [id2](030_AnalysisOfId_SepalWidth.html)
#' 
#' #Here we create a dynamic datatable containing the links.
#' Needs DT and data.table to run

if(require(DT) & require(data.table))
{
	library(DT)
	library(data.table)
	ids = fread(snakemake@input[['idslist']],header=FALSE)
	ids[,link:=paste0('<a href="', '030_AnalysisOfId_',V1,'.html">',V1,'</a>')]
	datatable(ids,escape=FALSE,filter = 'top')
}

#require(knitrBootstrap)
require(knitr)
opts_knit$set(root.dir = getwd())
require(rmarkdown)
opts_chunk$set(echo=TRUE,message=FALSE,error=FALSE,warning=FALSE, cache=F)
options(width=100)

source(".wBuild/render_child.R")
source(".wBuild/rmarkdown_show_hide_table.R")

#copy dependency to intermediate dir
intermediates_dir = tempfile()
i = dir.create(file.path(dirname(intermediates_dir), basename(intermediates_dir)), showWarnings = FALSE)
#i = file.copy(".wBuild/rmarkdown_show_hide_function.html",intermediates_dir)

file_input = snakemake@input[['RScript']]
file_output = snakemake@output[['wBhtml']]


sFile = tempfile()
write(spin(text=readChar(file_input, file.info(file_input)$size),knit=FALSE),sFile)
kProcessor = default_output_format(sFile)
if (kProcessor$name=="html_document")
{
	libPath = paste0(paste0(rep('../',length(strsplit(file_input,'/')[[1]])-1),collapse=''),paste0(dirname(file_output), '/libR'))
	#code_folding = ifelse(is.language(kProcessor$options$code_folding),"hide",kProcessor$options$code_folding)
	#format = html_document(toc = TRUE,toc_float = TRUE,fig_retina = NULL,code_folding=code_folding,self_contained=FALSE,lib_dir = libPath,css=c('lib/add_content_table.css','lib/leo_style.css'),df_print ='tibble')
	
	kProcessor$options$code_folding = ifelse(is.language(kProcessor$options$code_folding),"hide",kProcessor$options$code_folding)
	kProcessor$options$toc = TRUE
	kProcessor$options$toc_float = TRUE
	kProcessor$options$fig_retina = NULL
	kProcessor$options$self_contained = FALSE
	kProcessor$options$lib_dir = libPath
	kProcessor$options$css = c('lib/add_content_table.css','lib/leo_style.css')
	kProcessor$options$df_print ='tibble'
	format = do.call(eval(parse(text=kProcessor$name)),kProcessor$options)
}else{
	require(knitrBootstrap)
	format = do.call(eval(parse(text=kProcessor$name)),kProcessor$options)
}

render(file_input,output_dir = dirname(file_output),clean=TRUE,intermediates_dir = intermediates_dir, output_file = basename(file_output),output_format = format)

library(stringr)
library(gsubfn)
parseWBHeader2 = function(file, wildcards = list(), debug = T)
{
	# Are we interactive or in real snakemake run?
	if(exists('snakemake')&&is.null(snakemake@config[['wbDump']]))
	{
		return (snakemake)
	}
	#' Create dependency file
	system2('python',c('.wBuild/wbParse.py',file))
	#' Replace wildcards if necessary
	if(length(wildcards)>0)
	{
		names(wildcards) = paste0('{',names(wildcards),'}')
		dependencyfile = readLines('.wBuild.depend')
		dependencyfile_wild  <- gsubfn('\\{[^\\}]+\\}', wildcards,dependencyfile)
		writeLines(dependencyfile_wild, con=".wBuild.depend")
	}
	#' Extract rule name (1st in file)
	dependencyfile = readLines('.wBuild.depend')
	rule_name = str_extract(dependencyfile,'(?<=rule )[A-z0-9_]*')
	rule_name = rule_name[!is.na(rule_name)][1]
	
	if(debug==T)
	{
		writeLines(dependencyfile)
	}
	#' Run snakemake to dump snakemake object, dumps some error yet
	system2('snakemake',c(rule_name,'--config','wbDump=T','--nolock','--latency-wait','0','-q','-F','--allowed-rules',rule_name,'--mode','2'))
	#' Read snakemake object in
	snakemake <<- readRDS('.wBuild/snakemake.dump')
}
#
#parseWBHeader2('Scripts/Analysis1/010_BasicInput/020_BasicInput.R',debug=F)
#parseWBHeader2(file ='Scripts/Analysis1/050_PythonCode/030_AnalysisTemplate.R',list(id='anton'))
#parseWBHeader2(file='Scripts/Analysis1/050_PythonCode/040_IndexIDs.R')

#'---
#' title: Basic Input Demo
#' author: Leonhard Wachutka, Jun Cheng
#' wb:
#'  input: 
#'  - iris: "Data/{wbP}/iris.RDS"
#'  output:
#'  - pca: "{wbPD_P}/pca.RDS"
#' output:
#'  html_document:
#'   code_folding: show
#'   code_download: TRUE
#' 
#'---

# The following two commands make it possible to run wbReadRDS or snakemake@inputs
# while running in the interactive R session (say in RStudio)
source('.wBuild/wBuildParser.R')
parseWBHeader("Scripts/Analysis1/020_InputOutput/020_InputOutput.R")


iris_df <- wbReadRDS("iris") # shorthand for readRDS(snakemake@input[["iris"]])

##' ## PCA analysis of iris
# log transform 
log.ir <- log(iris_df[, 1:4])
ir.species <- iris_df[, 5]
 
# apply PCA - scale. = TRUE is highly 
# advisable, but default is FALSE. 
ir.pca <- prcomp(log.ir,
                 center = TRUE,
                 scale. = TRUE) 

pca <- as.matrix(log.ir) %*% ir.pca$rotation
pca <- as.data.frame(pca)
pca$Species <- iris_df$Species

wbSaveRDS(pca, 'pca') # shorthand for saveRDS(pca, snakemake@output[["pca"]])

#'---
#' title: Basic Input Demo
#' author: Leonhard Wachutka, Jun Cheng
#' wb:
#'  input: 
#'  - iris: "Data/{wbP}/iris.RDS"
#' output:
#'  html_document:
#'   code_folding: show
#'   code_download: TRUE
#'---
#' #Basic Demo
source('.wBuild/wBuildParser.R')
parseWBHeader("Scripts/Analysis1/010_BasicInput/020_BasicInput.R")

# wbReadRDS is a readRDS command that aware of inputs by referring to their names 
iris_df <- wbReadRDS('iris')
plot(iris_df)
#' #show some markdown features here.

# Input and Output

In this section, we show how to define input and output, to build dependent computational graph. 

In file `020_InputOutput.R`, we define in the yaml header input as `iris` data, and output file name and path, refered as `pca`. `type:script` means wBuild will only excute the file if any of the output file is reqested, but do not render the file into a html format.

In file `030_VisualizePCA.R`, we are requesting the `pca` result that is computed from `020_InputOutput.R`, which means, file `030_VisualizePCA.R` is dependent on the result from `020_InputOutput.R`.

Basic Yaml Header

```
#'---
#' title: Basic Input Demo
#' author: Leonhard Wachutka
#' wb:
#'  input: 
#'  - iris: "Data/{wbP}/iris.RDS"
#'  output:
#'  - pca: " {wbPD_P}/pca.RDS"
#' type: script
#'---
```

wBuild requires users to define information of the scripts in Rmarkdon yaml header. Besides standard Rmarkdown header, wBuild reads "rules" from `wb` block. Important tags for this block are `input` and `output`. wBuild reads inputs and outputs, and build dependence graph. By default, the script will be excuted by taking the inputs and produce outputs (if any), and rendered the script into a html format. 

For instance, in the demo `020_BacicInput.R`, we define `iris` data from `Data/{wbP}/iris.RDS` as input. In the body of the script, the input/output data will be refered by name. It is of course also possible ot use absolute path, but using the pre-defined place-holders like `wbP` (explained bellow) gives flexibility for resuing existing code. 

# Refer input or output variable by name
`wbReadRDS`  is a readRDS command that aware of inputs by referring to their names. For instance, `iris` will be refered to `Data/{wbP}/iris.RDS` in this case. One can alternatively refer input or output by name using `snakemake@input[[input_variable_name]]` or `snakemake@output[[output_variable_name]]` correspondingly. 

# wBuild place-holder dictionary

wbPD: [output directory for processed data] `Output/ProcessedData`

wbP: [current project] `Analysis1` 

wbPP: [subfolder name] `020_InputOutput`

wbPD_P: [output directory for processed data]/[current project] `Output/ProcessedData/Analysis1`

wbPD_PP: [output directory for processed data]/[current project]/[subfolder name] `Output/ProcessedData/Analysis1/020_InputOutput`

# Use native python code in yaml header

## Example: apply a analysis template by ids

This section we demonstrate how to use native python code in yaml header.

Python code can be included in the yaml header in `py` block.

```
#'---
#' wb:
#'  py:
#'  - | 
#'   with open('Data/ids.txt') as f:
#'    ids = f.read().splitlines()
#'  input:
#'  - idslist: "Data/ids.txt"
#'  - columns: "`sm expand('Output/html/030_AnalysisOfId_{id}.html', id=ids)`"
#'---
```

`sm ...` is escape for snakemake syntax. 
In this example, what happens is as follows:
1. python code under `py` block is excuted. ids stored in `Data/ids.txt` file will be read into `ids` variable. 
2. `sm expand('Output/html/030_AnalysisOfId_{id}.html', id=ids)` will expand into `Output/html/030_AnalysisOfId_{id}.html` for `{id}` in `ids`. These files are listed as inputs (required) for the current script. 
3. snakemake will then look for the script that create these files, which will be `030_AnalysisTemplate.R`, as `Output/html/030_AnalysisOfId_{id}.html` is listed as output for `030_AnalysisTemplate.R`.
4. `Data/ids.txt` is listed as an input, so that everytime `Data/ids.txt` file changed, snakemake will reapply `030_AnalysisTemplate.R` script to all `ids`.

# Use of native snakemake rules

Native snakemake rules can be defined in Snakefile in the project root directory. 

Here, we show one example of using shell command to download `iris.data` from web, save into `Data/iris_downloaded.data`. This file will then be served as input for script `020_Snakefile.R`

`Snakefile`:

```yaml
configfile: "wbuild.yaml"
include: ".wBuild/wBuild.snakefile"

rule all:
	input: rules.Index.output, "Output/html/readme.html"
	output: touch("Output/all.done")

rule downloadIris:
	output: 'Data/iris_downloaded.data'
	shell: "wget http://archive.ics.uci.edu/ml/machine-learning-databases/iris/iris.data > {output}"

```

# Specify snakemake options in `wb` block

One can also specify any snakemake options like `threads` in `wb` block and refere to them in the script. For instance, in script `020_Snakefile.R`, we specify 10 threads:

```
#' wb:
#'  input: 
#'  - iris: "Data/iris_downloaded.data"
#'  threads: 10
```

The specified variables can then be refered by name in the script: `snakemake@threads`.
